## pigpio 1.68

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(pigpio)

set(CMAKE_C_FLAGS "-O3 -Wall -pthread")
set(PIGPIO_FLAGS "-L. -lrt")
#set(DESTDIR ${CMAKE_CURRENT_SOURCE_DIR}/build/dest)

# libpigpio.so
add_library(pigpio SHARED pigpio.c command.c custom.cext)
set_property(TARGET pigpio
	PROPERTY POSITION_INDEPENDENT_CODE ON
)

# libpigpiod_if.so
add_library(pigpiod_if SHARED pigpiod_if.c command.c)
set_property(TARGET pigpiod_if
	PROPERTY POSITION_INDEPENDENT_CODE ON
)

# libpigpiod_if2.so
add_library(pigpiod_if2 SHARED pigpiod_if2.c command.c)
set_property(TARGET pigpiod_if2
	PROPERTY POSITION_INDEPENDENT_CODE ON
)

# x_pigpio
add_executable(x_pigpio x_pigpio.c)
add_dependencies(x_pigpio pigpio)
target_link_libraries(x_pigpio
	${PIGPIO_FLAGS}
	-lpigpio
)

# x_pigpiod_if
add_executable(x_pigpiod_if x_pigpiod_if.c)
add_dependencies(x_pigpiod_if pigpiod_if)
target_link_libraries(x_pigpiod_if
	${PIGPIO_FLAGS}
	-lpigpiod_if
)

# x_pigpiod_if2
add_executable(x_pigpiod_if2 x_pigpiod_if2.c)
add_dependencies(x_pigpiod_if2 pigpiod_if2)
target_link_libraries(x_pigpiod_if2
	${PIGPIO_FLAGS}
	-lpigpiod_if2
)

# pigpiod
add_executable(pigpiod pigpiod.c)
add_dependencies(pigpiod pigpio)
target_link_libraries(pigpiod
	${PIGPIO_FLAGS}
	-lpigpio
)

# pigs
add_executable(pigs pigs.c command.c)

# pig2vcd
add_executable(pig2vcd pig2vcd.c command.c)

# install
install(DIRECTORY
	DESTINATION ${DESTDIR}/opt/pigpio/cgi
	PATTERN ""
	PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
		GROUP_READ GROUP_EXECUTE
		WORLD_READ WORLD_EXECUTE
)

install(TARGETS pigpio pigpiod_if pigpiod_if2 pig2vcd pigpiod pigs
	LIBRARY DESTINATION ${DESTDIR}/usr/local/lib
	RUNTIME DESTINATION ${DESTDIR}/usr/local/bin
)

install(FILES pigpio.h pigpiod_if.h pigpiod_if2.h
	DESTINATION ${DESTDIR}/usr/local/include
	PERMISSIONS OWNER_READ OWNER_WRITE
		GROUP_READ
		WORLD_READ
)

file(GLOB man_1_SRC "*.1")
install(FILES ${man_1_SRC}
	DESTINATION ${DESTDIR}/usr/local/man/man1
	PERMISSIONS OWNER_READ OWNER_WRITE
		GROUP_READ
		WORLD_READ
)

file(GLOB man_3_SRC "*.3")
install(FILES ${man_3_SRC}
	DESTINATION ${DESTDIR}/usr/local/man/man3
	PERMISSIONS OWNER_READ OWNER_WRITE
		GROUP_READ
		WORLD_READ
)

file(GLOB setup_SRC "setup.py")
find_program(PYTHON2_FOUND python2)
if(PYTHON2_FOUND)
	install(CODE "execute_process(COMMAND cd ${CMAKE_SOURCE_DIR} && python2 ${setup_SRC} install)")
endif()
find_program(PYTHON3_FOUND python3)
if(PYTHON3_FOUND)
	install(CODE "execute_process(COMMAND cd ${CMAKE_SOURCE_DIR} && python3 ${setup_SRC} install)")
endif()

install(CODE "execute_process(COMMAND ldconfig)")

# uninstall
if(PYTHON2_FOUND)
	set(PY2_CMD python2 ${setup_SRC} install --record /tmp/pigpio > /dev/null)
	set(PY2_CMD ${PY2_CMD} && xargs rm -f < /tmp/pigpio > /dev/null)
endif()

if(PYTHON3_FOUND)
	set(PY3_CMD python3 ${setup_SRC} install --record /tmp/pigpio > /dev/null)
	set(PY3_CMD ${PY3_CMD} && xargs rm -f < /tmp/pigpio > /dev/null)
endif()

add_custom_target(uninstall
	COMMAND rm -f ${DESTDIR}/usr/local/include/pigpio.h
	COMMAND rm -f ${DESTDIR}/usr/local/include/pigpiod_if.h
	COMMAND rm -f ${DESTDIR}/usr/local/include/pigpiod_if2.h
	COMMAND rm -f ${DESTDIR}/usr/local/lib/libpigpio.so
	COMMAND rm -f ${DESTDIR}/usr/local/lib/libpigpiod_if.so
	COMMAND rm -f ${DESTDIR}/usr/local/lib/libpigpiod_if2.so
	COMMAND rm -f ${DESTDIR}/usr/local/bin/pig2vcd
	COMMAND rm -f ${DESTDIR}/usr/local/bin/pigpiod
	COMMAND rm -f ${DESTDIR}/usr/local/bin/pigs
	COMMAND cd ${CMAKE_SOURCE_DIR} && ${PY2_CMD}
	COMMAND cd ${CMAKE_SOURCE_DIR} && ${PY3_CMD}
	COMMAND rm -f ${DESTDIR}/usr/local/man/man1/pig*.1
	COMMAND rm -f ${DESTDIR}/usr/local/man/man3/pig*.3
	COMMAND ldconfig
)

=== Makefile ===
#
# Set CROSS_PREFIX to prepend to all compiler tools at once for easier
# cross-compilation.
CROSS_PREFIX =
CC           = $(CROSS_PREFIX)gcc
AR           = $(CROSS_PREFIX)ar
RANLIB       = $(CROSS_PREFIX)ranlib
SIZE         = $(CROSS_PREFIX)size
STRIP        = $(CROSS_PREFIX)strip
SHLIB        = $(CC) -shared
STRIPLIB     = $(STRIP) --strip-unneeded

CFLAGS	+= -O3 -Wall -pthread

LIB1     = libpigpio.so
OBJ1     = pigpio.o command.o

LIB2     = libpigpiod_if.so
OBJ2     = pigpiod_if.o command.o

LIB3     = libpigpiod_if2.so
OBJ3     = pigpiod_if2.o command.o

LIB      = $(LIB1) $(LIB2) $(LIB3)

ALL     = $(LIB) x_pigpio x_pigpiod_if x_pigpiod_if2 pig2vcd pigpiod pigs

LL1      = -L. -lpigpio -pthread -lrt

LL2      = -L. -lpigpiod_if -pthread -lrt

LL3      = -L. -lpigpiod_if2 -pthread -lrt

prefix = /usr/local
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
includedir = $(prefix)/include
libdir = $(prefix)/lib
mandir = $(prefix)/man

all:	$(ALL)

lib:	$(LIB)

pigpio.o: pigpio.c pigpio.h command.h custom.cext
	$(CC) $(CFLAGS) -fpic -c -o pigpio.o pigpio.c

pigpiod_if.o: pigpiod_if.c pigpio.h command.h pigpiod_if.h
	$(CC) $(CFLAGS) -fpic -c -o pigpiod_if.o pigpiod_if.c

pigpiod_if2.o: pigpiod_if2.c pigpio.h command.h pigpiod_if2.h
	$(CC) $(CFLAGS) -fpic -c -o pigpiod_if2.o pigpiod_if2.c

command.o: command.c pigpio.h command.h
	$(CC) $(CFLAGS) -fpic -c -o command.o command.c

x_pigpio:	x_pigpio.o $(LIB1)
	$(CC) -o x_pigpio x_pigpio.o $(LL1)

x_pigpiod_if:	x_pigpiod_if.o $(LIB2)
	$(CC) -o x_pigpiod_if x_pigpiod_if.o $(LL2)

x_pigpiod_if2:	x_pigpiod_if2.o $(LIB3)
	$(CC) -o x_pigpiod_if2 x_pigpiod_if2.o $(LL3)

pigpiod:	pigpiod.o $(LIB1)
	$(CC) -o pigpiod pigpiod.o $(LL1)
	$(STRIP) pigpiod

pigs:		pigs.o command.o
	$(CC) -o pigs pigs.o command.o
	$(STRIP) pigs

pig2vcd:	pig2vcd.o
	$(CC) -o pig2vcd pig2vcd.o
	$(STRIP) pig2vcd

clean:
	rm -f *.o *.i *.s *~ $(ALL)

install:	$(ALL)
	install -m 0755 -d                $(DESTDIR)/opt/pigpio/cgi
	install -m 0755 -d                $(DESTDIR)$(includedir)
	install -m 0644 pigpio.h          $(DESTDIR)$(includedir)
	install -m 0644 pigpiod_if.h      $(DESTDIR)$(includedir)
	install -m 0644 pigpiod_if2.h     $(DESTDIR)$(includedir)
	install -m 0755 -d                $(DESTDIR)$(libdir)
	install -m 0755 libpigpio.so      $(DESTDIR)$(libdir)
	install -m 0755 libpigpiod_if.so  $(DESTDIR)$(libdir)
	install -m 0755 libpigpiod_if2.so $(DESTDIR)$(libdir)
	install -m 0755 -d                $(DESTDIR)$(bindir)
	install -m 0755 pig2vcd           $(DESTDIR)$(bindir)
	install -m 0755 pigpiod           $(DESTDIR)$(bindir)
	install -m 0755 pigs              $(DESTDIR)$(bindir)
	if which python2; then python2 setup.py install; fi
	if which python3; then python3 setup.py install; fi
	install -m 0755 -d                $(DESTDIR)$(mandir)/man1
	install -m 0644 *.1               $(DESTDIR)$(mandir)/man1
	install -m 0755 -d                $(DESTDIR)$(mandir)/man3
	install -m 0644 *.3               $(DESTDIR)$(mandir)/man3
	ldconfig

uninstall:
	rm -f $(DESTDIR)$(includedir)/pigpio.h
	rm -f $(DESTDIR)$(includedir)/pigpiod_if.h
	rm -f $(DESTDIR)$(includedir)/pigpiod_if2.h
	rm -f $(DESTDIR)$(libdir)/libpigpio.so
	rm -f $(DESTDIR)$(libdir)/libpigpiod_if.so
	rm -f $(DESTDIR)$(libdir)/libpigpiod_if2.so
	rm -f $(DESTDIR)$(bindir)/pig2vcd
	rm -f $(DESTDIR)$(bindir)/pigpiod
	rm -f $(DESTDIR)$(bindir)/pigs
	if which python2; then python2 setup.py install --record /tmp/pigpio >/dev/null; xargs rm -f < /tmp/pigpio >/dev/null; fi
	if which python3; then python3 setup.py install --record /tmp/pigpio >/dev/null; xargs rm -f < /tmp/pigpio >/dev/null; fi
	rm -f $(DESTDIR)$(mandir)/man1/pig*.1
	rm -f $(DESTDIR)$(mandir)/man3/pig*.3
	ldconfig

$(LIB1):	$(OBJ1)
	$(SHLIB) -o $(LIB1) $(OBJ1)
	$(STRIPLIB) $(LIB1)
	$(SIZE)     $(LIB1)

$(LIB2):	$(OBJ2)
	$(SHLIB) -o $(LIB2) $(OBJ2)
	$(STRIPLIB) $(LIB2)
	$(SIZE)     $(LIB2)

$(LIB3):	$(OBJ3)
	$(SHLIB) -o $(LIB3) $(OBJ3)
	$(STRIPLIB) $(LIB3)
	$(SIZE)     $(LIB3)

# generated using gcc -MM *.c

pig2vcd.o: pig2vcd.c pigpio.h
pigpiod.o: pigpiod.c pigpio.h
pigs.o: pigs.c pigpio.h command.h pigs.h
x_pigpio.o: x_pigpio.c pigpio.h
x_pigpiod_if.o: x_pigpiod_if.c pigpiod_if.h pigpio.h
x_pigpiod_if2.o: x_pigpiod_if2.c pigpiod_if2.h pigpio.h

=== debian/changelog ===
pigpio (1.68-3) unstable; urgency=medium

  * Fix short description for libpigpiod-if-dev package.
  * Remove systemd stuff in debian/rules, since we don't ship the server.
  * Fix some screwups in 64-bit patch where PRIX64 was used where PRIXPTR should have been used.
  * Enable parallel building (Closes: 920142)

 -- Peter Michael Green <plugwash@debian.org>  Thu, 24 Jan 2019 13:25:48 +0000

pigpio (1.68-2) unstable; urgency=medium

  * Put packages into more appropriate sections.
  * Add dependencies on library packages to dev packages.
  * Add conflicts with old Raspberry pi foundatoin pigpio packages.

 -- Peter Michael Green <plugwash@debian.org>  Tue, 15 Jan 2019 23:01:01 +0000

pigpio (1.68-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: 908787).
  * Update debian/copyright with far more detail.
  * Package only client stuff for now, the server stuff is incompatible with
    Debian kernels.
  * Update to upstream release 68
  * Apply upstream fixes since release 68
    + Make DESTDIR work correctly.
    + Make "make uninstall" uninstall all man pages.
    + Add soversion to shared libraries.
  * Apply patches to add raspberry pi detection and make code build on
    64-bit without warnings.
  * Split packaging to comply with Debian policy.
  * Update standards version to 4.2.0
  * Build-depend on debhelper (>= 9.20160709) instead of dh-systemd
  * Remove ancient python version fields.
  * Install manpages correctly
  * Remove broken comments from top of manpages.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 10 Jan 2019 12:31:08 +0000

pigpio (1.64-1) stretch; urgency=medium

  * Upstream release V64

 -- Serge Schneider <serge@raspberrypi.org>  Mon, 11 Sep 2017 17:44:03 +0100

pigpio (1.60-1) jessie; urgency=medium

  * Upstream release V60

 -- Serge Schneider <serge@raspberrypi.org>  Thu, 12 Jan 2017 14:35:43 +0000

pigpio (1.30-1) jessie; urgency=medium

  * Initial release

 -- Serge Schneider <serge@raspberrypi.org>  Wed, 13 Apr 2016 12:15:37 +0100

=== debian/control ===
Source: pigpio
Section: utils
Priority: optional
Maintainer: Peter Michael Green <plugwash@debian.org>
Build-Depends: debhelper (>= 9.20160709), dh-python, python-all, python-setuptools,
  python3-all, python3-setuptools
Standards-Version: 4.2.0
Homepage: http://abyz.co.uk/rpi/pigpio/

Package: libpigpiod-if2-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client library for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides the libpigpiod_if2 client library

Package: libpigpiod-if1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client library for Raspberry Pi GPIO control (deprecated)
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides the deprecated libpigpiod_if client library

Package: libpigpiod-if-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libpigpiod-if1 (= ${binary:Version}), libpigpiod-if2-1 (= ${binary:Version})
Conflicts: pigpio (<< 1.68-1)
Description: Development headers for client libraries for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides development headers for the libpigpiod_if2 and
 libpigpiod_if client libraries.

Package: pigpio-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client tools for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides the pigs and pig2vcd tools.

Package: python-pigpio
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Recommends: pigpio
Description: Python module which talks to the pigpio daemon (Python 2)
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides the python 2 client library.

Package: python3-pigpio
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: pigpio
Description: Python module which talks to the pigpio daemon (Python 3)
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides the python 3 client library.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND = -Wno-format-security

%:
	dh $@ --with python2,python3 --parallel

override_dh_clean:
	rm -rf build
	dh_clean

## pigpio 1.78

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(pigpio LANGUAGES C VERSION 0.71)

list (APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

find_package(Threads REQUIRED)
find_package(RT REQUIRED)

option(BUILD_SHARED_LIBS "Create shared libraries" ON)

add_compile_options(-Wall)

# libpigpio.(so|a)
add_library(pigpio pigpio.c command.c custom.cext)

# libpigpiod_if.(so|a)
add_library(pigpiod_if pigpiod_if.c command.c)

# libpigpiod_if2.(so|a)
add_library(pigpiod_if2 pigpiod_if2.c command.c)

# x_pigpio
add_executable(x_pigpio x_pigpio.c)
target_link_libraries(x_pigpio pigpio RT::RT Threads::Threads)

# x_pigpiod_if
add_executable(x_pigpiod_if x_pigpiod_if.c)
target_link_libraries(x_pigpiod_if pigpiod_if RT::RT Threads::Threads)

# x_pigpiod_if2
add_executable(x_pigpiod_if2 x_pigpiod_if2.c)
target_link_libraries(x_pigpiod_if2 pigpiod_if2 RT::RT Threads::Threads)

# pigpiod
add_executable(pigpiod pigpiod.c)
target_link_libraries(pigpiod pigpio RT::RT Threads::Threads)

# pigs
add_executable(pigs pigs.c command.c)
target_link_libraries(pigs Threads::Threads)

# pig2vcd
add_executable(pig2vcd pig2vcd.c command.c)
target_link_libraries(pig2vcd Threads::Threads)

# Configure and install project

include (GenerateExportHeader)
include (CMakePackageConfigHelpers)

generate_export_header(${PROJECT_NAME})

install(TARGETS pigpio pigpiod_if pigpiod_if2 pig2vcd pigpiod pigs
    EXPORT ${PROJECT_NAME}Targets
	LIBRARY  DESTINATION lib
	ARCHIVE  DESTINATION lib
	RUNTIME  DESTINATION bin
	INCLUDES DESTINATION include
)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
	VERSION ${${PROJECT_NAME}_VERSION}
	COMPATIBILITY AnyNewerVersion
)

export(EXPORT ${PROJECT_NAME}Targets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake"
  NAMESPACE pigpio::
)

set(ConfigPackageLocation lib/cmake/${PROJECT_NAME})
install(EXPORT ${PROJECT_NAME}Targets
  FILE
    ${PROJECT_NAME}Targets.cmake
  NAMESPACE
    pigpio::
  DESTINATION
    ${ConfigPackageLocation}
)

install(
  FILES
    ${CMAKE_CURRENT_LIST_DIR}/cmake/${PROJECT_NAME}Config.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION
    ${ConfigPackageLocation}
)

install(FILES pigpio.h pigpiod_if.h pigpiod_if2.h
	DESTINATION include
	PERMISSIONS OWNER_READ OWNER_WRITE
		GROUP_READ
		WORLD_READ
)

file(GLOB man_1_SRC "*.1")
install(FILES ${man_1_SRC}
	DESTINATION man/man1
	PERMISSIONS OWNER_READ OWNER_WRITE
		GROUP_READ
		WORLD_READ
)

file(GLOB man_3_SRC "*.3")
install(FILES ${man_3_SRC}
	DESTINATION man/man3
	PERMISSIONS OWNER_READ OWNER_WRITE
		GROUP_READ
		WORLD_READ
)

# Install python modules.
find_package(Python COMPONENTS Interpreter QUIET)

if(Python_FOUND)
	configure_file(${CMAKE_CURRENT_LIST_DIR}/cmake/setup.py.in
		${CMAKE_CURRENT_BINARY_DIR}/setup.py
	)

	install(CODE "execute_process(COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py install)")
endif()

# package project

include (CPack)

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,8 @@
 STRIP        = $(CROSS_PREFIX)strip
 SHLIB        = $(CC) -shared
 STRIPLIB     = $(STRIP) --strip-unneeded
+
+SOVERSION    = 1
 
 CFLAGS	+= -O3 -Wall -pthread
 
@@ -76,29 +78,40 @@
 	$(STRIP) pig2vcd
 
 clean:
-	rm -f *.o *.i *.s *~ $(ALL)
+	rm -f *.o *.i *.s *~ $(ALL) *.so.$(SOVERSION)
+
+ifeq ($(DESTDIR),)
+  PYINSTALLARGS =
+else
+  PYINSTALLARGS = --root=$(DESTDIR)
+endif
 
 install:	$(ALL)
-	install -m 0755 -d                $(DESTDIR)/opt/pigpio/cgi
-	install -m 0755 -d                $(DESTDIR)$(includedir)
-	install -m 0644 pigpio.h          $(DESTDIR)$(includedir)
-	install -m 0644 pigpiod_if.h      $(DESTDIR)$(includedir)
-	install -m 0644 pigpiod_if2.h     $(DESTDIR)$(includedir)
-	install -m 0755 -d                $(DESTDIR)$(libdir)
-	install -m 0755 libpigpio.so      $(DESTDIR)$(libdir)
-	install -m 0755 libpigpiod_if.so  $(DESTDIR)$(libdir)
-	install -m 0755 libpigpiod_if2.so $(DESTDIR)$(libdir)
-	install -m 0755 -d                $(DESTDIR)$(bindir)
-	install -m 0755 pig2vcd           $(DESTDIR)$(bindir)
-	install -m 0755 pigpiod           $(DESTDIR)$(bindir)
-	install -m 0755 pigs              $(DESTDIR)$(bindir)
-	if which python2; then python2 setup.py install; fi
-	if which python3; then python3 setup.py install; fi
-	install -m 0755 -d                $(DESTDIR)$(mandir)/man1
-	install -m 0644 *.1               $(DESTDIR)$(mandir)/man1
-	install -m 0755 -d                $(DESTDIR)$(mandir)/man3
-	install -m 0644 *.3               $(DESTDIR)$(mandir)/man3
+	install -m 0755 -d                             $(DESTDIR)/opt/pigpio/cgi
+	install -m 0755 -d                             $(DESTDIR)$(includedir)
+	install -m 0644 pigpio.h                       $(DESTDIR)$(includedir)
+	install -m 0644 pigpiod_if.h                   $(DESTDIR)$(includedir)
+	install -m 0644 pigpiod_if2.h                  $(DESTDIR)$(includedir)
+	install -m 0755 -d                             $(DESTDIR)$(libdir)
+	install -m 0755 libpigpio.so.$(SOVERSION)      $(DESTDIR)$(libdir)
+	install -m 0755 libpigpiod_if.so.$(SOVERSION)  $(DESTDIR)$(libdir)
+	install -m 0755 libpigpiod_if2.so.$(SOVERSION) $(DESTDIR)$(libdir)
+	cd $(DESTDIR)$(libdir) && ln -fs libpigpio.so.$(SOVERSION)      libpigpio.so
+	cd $(DESTDIR)$(libdir) && ln -fs libpigpiod_if.so.$(SOVERSION)  libpigpiod_if.so
+	cd $(DESTDIR)$(libdir) && ln -fs libpigpiod_if2.so.$(SOVERSION) libpigpiod_if2.so
+	install -m 0755 -d                             $(DESTDIR)$(bindir)
+	install -m 0755 pig2vcd                        $(DESTDIR)$(bindir)
+	install -m 0755 pigpiod                        $(DESTDIR)$(bindir)
+	install -m 0755 pigs                           $(DESTDIR)$(bindir)
+	if which python2; then python2 setup.py install $(PYINSTALLARGS); fi
+	if which python3; then python3 setup.py install $(PYINSTALLARGS); fi
+	install -m 0755 -d                             $(DESTDIR)$(mandir)/man1
+	install -m 0644 p*.1                           $(DESTDIR)$(mandir)/man1
+	install -m 0755 -d                             $(DESTDIR)$(mandir)/man3
+	install -m 0644 p*.3                           $(DESTDIR)$(mandir)/man3
+ifeq ($(DESTDIR),)
 	ldconfig
+endif
 
 uninstall:
 	rm -f $(DESTDIR)$(includedir)/pigpio.h
@@ -107,27 +120,36 @@
 	rm -f $(DESTDIR)$(libdir)/libpigpio.so
 	rm -f $(DESTDIR)$(libdir)/libpigpiod_if.so
 	rm -f $(DESTDIR)$(libdir)/libpigpiod_if2.so
+	rm -f $(DESTDIR)$(libdir)/libpigpio.so.$(SOVERSION)
+	rm -f $(DESTDIR)$(libdir)/libpigpiod_if.so.$(SOVERSION)
+	rm -f $(DESTDIR)$(libdir)/libpigpiod_if2.so.$(SOVERSION)
 	rm -f $(DESTDIR)$(bindir)/pig2vcd
 	rm -f $(DESTDIR)$(bindir)/pigpiod
 	rm -f $(DESTDIR)$(bindir)/pigs
-	if which python2; then python2 setup.py install --record /tmp/pigpio >/dev/null; xargs rm -f < /tmp/pigpio >/dev/null; fi
-	if which python3; then python3 setup.py install --record /tmp/pigpio >/dev/null; xargs rm -f < /tmp/pigpio >/dev/null; fi
+	if which python2; then python2 setup.py install $(PYINSTALLARGS) --record /tmp/pigpio >/dev/null; sed 's!^!$(DESTDIR)!' < /tmp/pigpio | xargs rm -f >/dev/null; fi
+	if which python3; then python3 setup.py install $(PYINSTALLARGS) --record /tmp/pigpio >/dev/null; sed 's!^!$(DESTDIR)!' < /tmp/pigpio | xargs rm -f >/dev/null; fi
 	rm -f $(DESTDIR)$(mandir)/man1/pig*.1
+	rm -f $(DESTDIR)$(mandir)/man1/libpigpio*.1
 	rm -f $(DESTDIR)$(mandir)/man3/pig*.3
+ifeq ($(DESTDIR),)
 	ldconfig
+endif
 
 $(LIB1):	$(OBJ1)
-	$(SHLIB) -o $(LIB1) $(OBJ1)
+	$(SHLIB) -pthread -Wl,-soname,$(LIB1).$(SOVERSION) -o $(LIB1).$(SOVERSION) $(OBJ1)
+	ln -fs $(LIB1).$(SOVERSION) $(LIB1)
 	$(STRIPLIB) $(LIB1)
 	$(SIZE)     $(LIB1)
 
 $(LIB2):	$(OBJ2)
-	$(SHLIB) -o $(LIB2) $(OBJ2)
+	$(SHLIB) -pthread -Wl,-soname,$(LIB2).$(SOVERSION) -o $(LIB2).$(SOVERSION) $(OBJ2)
+	ln -fs $(LIB2).$(SOVERSION) $(LIB2)
 	$(STRIPLIB) $(LIB2)
 	$(SIZE)     $(LIB2)
 
 $(LIB3):	$(OBJ3)
-	$(SHLIB) -o $(LIB3) $(OBJ3)
+	$(SHLIB) -pthread -Wl,-soname,$(LIB3).$(SOVERSION) -o $(LIB3).$(SOVERSION) $(OBJ3)
+	ln -fs $(LIB3).$(SOVERSION) $(LIB3)
 	$(STRIPLIB) $(LIB3)
 	$(SIZE)     $(LIB3)

=== debian/changelog ===
pigpio (1.78-1.1+rpi2) trixie-staging; urgency=medium

  * Fix uninstallability after time64 changes.

 -- Peter Michael Green <plugwash@raspbian.org>  Mon, 03 Jun 2024 21:58:36 +0000

pigpio (1.78-1.1+rpi1) trixie-staging; urgency=medium

  [changes brought forward from 1.68-3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Thu, 24 Jan 2019 13:31:37 +0000]
  * Add back systemd stuff and ensure systemd unit is only installed in pigpiod package.
  * Add server related packages and metapackage.

 -- Raspbian forward porter <root@raspbian.org>  Fri, 31 May 2024 21:10:37 +0000

pigpio (1.78-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063256

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 20:51:34 +0000

pigpio (1.78-1) unstable; urgency=medium

  * New upstream release.
    + adds pi4 support (though server is currently disabled in Debian package)

 -- Peter Michael Green <plugwash@debian.org>  Thu, 28 Jan 2021 19:08:40 +0000

pigpio (1.68-4) unstable; urgency=medium

  * Remove python 2 support (Closes: 937289).
    + Drop python-pigpio package.
    + Update control and rules.

 -- Peter Michael Green <plugwash@debian.org>  Fri, 30 Aug 2019 20:31:21 +0000

=== debian/control ===
Source: pigpio
Section: utils
Priority: optional
Maintainer: Peter Michael Green <plugwash@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 9.20160709), dh-python,
  python3-all, python3-setuptools
Standards-Version: 4.2.0
Homepage: http://abyz.co.uk/rpi/pigpio/

Package: libpigpiod-if2-1t64
Provides: ${t64:Provides}
Replaces: libpigpiod-if2-1
Breaks: libpigpiod-if2-1 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client library for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely. Currently only the client side is Packaged
 in Debian as the server side is incompatible with Debian kernels.
 .
 This package provides the libpigpiod_if2 client library

Package: libpigpiod-if1t64
Provides: ${t64:Provides}
Replaces: libpigpiod-if1
Breaks: libpigpiod-if1 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client library for Raspberry Pi GPIO control (deprecated)
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides the deprecated libpigpiod_if client library

Package: libpigpiod-if-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libpigpiod-if1t64 (= ${binary:Version}), libpigpiod-if2-1t64 (= ${binary:Version})
Conflicts: pigpio (<< 1.68-1)
Description: Development headers for client libraries for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides development headers for the libpigpiod_if2 and
 libpigpiod_if client libraries.

Package: libpigpio1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Library for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides the pigpio library used to access the GPIO directly.
 (used by the pigpiod server, can also be used directly if desired)

Package: libpigpio-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libpigpio1 (= ${binary:Version})
Conflicts: pigpio (<< 1.68-1)
Description: Client tools for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides the development headers for the pigpio library used to
 access the GPIO directly. 

Package: pigpio-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client tools for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides the pigs and pig2vcd tools.

Package: pigpiod
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: pigpio (<< 1.68-1)
Description: Client tools for Raspberry Pi GPIO control
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides the pigpiod daemon which offers a socket and pipe
 interface to the underlying library.

Package: pigpio
Architecture: any
Depends: 
 libpigpiod-if2-1t64 (= ${binary:Version}),
 libpigpiod-if1t64 (= ${binary:Version}),
 libpigpiod-if-dev (= ${binary:Version}),
 pigpio-tools (= ${binary:Version}),
 libpigpio1 (= ${binary:Version}),
 libpigpio-dev (= ${binary:Version}),
 pigpio-tools (= ${binary:Version}),
 pigpiod (= ${binary:Version}),
 pigpio (= ${binary:Version})
Description:  Raspberry Pi GPIO control transitional package.
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This is a transitional package that installs everything that was previously
 included in the pigpio package before the package split 

Package: python3-pigpio
Section: python
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: pigpio
Description: Python module which talks to the pigpio daemon (Python 3)
 Pigpio is a set of software which allows control of the General Purpose Input
 Outputs (GPIO) locally or remotely.
 .
 This package provides the python 3 client library.

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,14 @@
 export DEB_CFLAGS_MAINT_APPEND = -Wno-format-security
 
 %:
-	dh $@ --with python2,python3 --parallel
+	dh $@ --with python3,systemd --parallel
 
 override_dh_clean:
 	rm -rf build
 	dh_clean
 
+override_dh_systemd_start:
+	dh_systemd_start -p pigpiod --name pigpiod --no-start
+
+override_dh_systemd_enable:
+	dh_systemd_enable -p pigpiod --name pigpiod --no-enable

## pigpio 1.79

=== debian/changelog ===
pigpio (1.79-1+rpt1) buster; urgency=medium

  * Re-enable python2 package
  * New upstream release.

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 30 Mar 2021 16:42:40 +0100

pigpio (1.78-1+rpi1~buster) buster-staging; urgency=medium

  * Rebuild for buster.

 -- Peter Michael Green <plugwash@raspbian.org>  Fri, 19 Feb 2021 04:46:56 +0000

pigpio (1.78-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.68-3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Thu, 24 Jan 2019 13:31:37 +0000]
  * Add back systemd stuff and ensure systemd unit is only installed in pigpiod package.
  * Add server related packages and metapackage.

 -- Raspbian forward porter <root@raspbian.org>  Fri, 05 Feb 2021 14:24:57 +0000
